package org.gcube.datacatalogue.ckanutillibrary.ckan;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonMappingException;

import eu.trentorise.opendata.jackan.model.CkanDataset;
import eu.trentorise.opendata.jackan.model.CkanResource;

// TODO: Auto-generated Javadoc
/**
 * The Class MarshUnmarshCkanObject.
 *
 * @author Francesco Mangiacrapa at ISTI-CNR Pisa (Italy)
 * Jun 3, 2020
 */
public class MarshUnmarshCkanObject {
	
	/**
	 * To ckan dataset.
	 *
	 * @param jsonDataset the json dataset
	 * @return the ckan dataset
	 * @throws JsonParseException the json parse exception
	 * @throws JsonMappingException the json mapping exception
	 * @throws IOException Signals that an I/O exception has occurred.
	 */
	public static CkanDataset toCkanDataset(String jsonDataset) throws JsonParseException, JsonMappingException, IOException {
		return ExtendCkanClient.getObjectMapper().readValue(jsonDataset, CkanDataset.class);	
	}
	
	
	/**
	 * To ckan resource.
	 *
	 * @param jsonResource the json resource
	 * @return the ckan resource
	 * @throws JsonParseException the json parse exception
	 * @throws JsonMappingException the json mapping exception
	 * @throws IOException Signals that an I/O exception has occurred.
	 */
	public static CkanResource toCkanResource(String jsonResource) throws JsonParseException, JsonMappingException, IOException {
		return ExtendCkanClient.getObjectMapper().readValue(jsonResource, CkanResource.class);	
	}
	
	
	/**
	 * To json value resource.
	 *
	 * @param resource the resource
	 * @return the string
	 * @throws JsonProcessingException the json processing exception
	 */
	public static String toJsonValueResource(CkanResource resource) throws JsonProcessingException{
		return ExtendCkanClient.getObjectMapper().writeValueAsString(resource);
	}

	
	/**
	 * To json value dataset.
	 *
	 * @param dataset the dataset
	 * @return the string
	 * @throws JsonProcessingException the json processing exception
	 */
	public static String toJsonValueDataset(CkanDataset dataset) throws JsonProcessingException {
		return ExtendCkanClient.getObjectMapper().writeValueAsString(dataset);
	}

}
